Freedesktop Standards utilitys

Micro implementations of Freedesktop.org standards for .desktop files, icon themeing and vfolders. More...

## Macros

#define | mb_dot_desktop_folders_get_cnt(f) (f)->n_entries
| Gets a count of .directory entrys ( folders ) in an #MBDotDesktopFolder .
#define | mb_dot_desktop_folders_enumerate(ddfolders, ddentry)
| Enumerates the #MBDotDesktopFolderEntry entrys in a #MBDotDesktopFolders struct.
#define | mb_dot_desktop_folder_entry_get_name(f) (f)->name
| Gets the name of a #MBDotDesktopFolderEntry.
#define | mb_dot_desktop_folder_entry_get_icon(f) (f)->icon
| Gets the icon filename ( not path ) of a #MBDotDesktopFolderEntry.
#define | mb_dot_desktop_folder_entry_get_match(f) (f)->match
| Gets the categorie match string of a #MBDotDesktopFolderEntry.

## Typedefs

typedef struct MBDotDesktop | MBDotDesktop
| Opaque type used for representing a parsed .desktop file.

## Functions

MBDotDesktop * | mb_dotdesktop_new_from_file (const char *filename)
| Parses a .desktop file and creates a localised MBDotDesktop instance. More...
unsigned char * | mb_dotdesktop_get (MBDotDesktop *dd, char *key)
| Gets the localised value for a specified key in MBDotDesktop instance. More...
char * | mb_dotdesktop_get_filename (MBDotDesktop *dd)
| Gets the filename from MBDotDesktop instance. More...
char * | mb_dotdesktop_get_exec (MBDotDesktop *dd)
| Get the Exec key from a MBDotDesktop instance, with the %-escapes expanded. More...
void | mb_dotdesktop_free (MBDotDesktop *dd)
| Free's a MBDotDesktop instance. More...
char * | mb_dot_desktop_icon_get_full_path (char *theme_name, int size_wanted, char *icon_name)
| Gets the full path for an specified icon. More...
MBDotDesktopFolders * | mb_dot_desktop_folders_new (const char *vfolder_path)
| Parses a 'vfolder style' directory of .directory entrys used for building simple hireachies of .desktop files. More...
void | mb_dot_desktop_folders_free (MBDotDesktopFolders *folders)
| Frees a dotdesktopfolders instance. More...

## Detailed Description

Micro implementations of Freedesktop.org standards for .desktop files, icon themeing and vfolders.

## Function Documentation

void mb_dot_desktop_folders_free | ( | MBDotDesktopFolders * | folders | ) |

Frees a dotdesktopfolders instance.

Parameters

  folders | dotdesktopfolders instance

MBDotDesktopFolders* mb_dot_desktop_folders_new | ( | const char * | vfolder_path | ) |

Parses a 'vfolder style' directory of .directory entrys used for building simple hireachies of .desktop files.

Expect a directory containing a root.order file, which lists a .directory file per line. Each of these entry in then parsed in the specified order as a #MBDotDesktopFolderEntry instance.

Parameters

  vfolder_path | path to .directory files

Returns
  A dotdesktopfolders object instance

char* mb_dot_desktop_icon_get_full_path | ( | char * | theme_name,
|  | int | size_wanted,
|  | char * | icon_name
| ) |  |

Gets the full path for an specified icon.

The function allocates memory for the returned data, this should be freed by the caller.

Parameters

  theme_name | name of theme to get the icon for
  size_wanted | icon dimention wanted in pixels
  icon_name | the filename

Returns
  the full path to the found icon, or NULL on fail.

void mb_dotdesktop_free | ( | MBDotDesktop * | dd | ) |

Free's a MBDotDesktop instance.

Parameters

  dd | MBDotDesktop instance

unsigned char* mb_dotdesktop_get | ( | MBDotDesktop * | dd,
|  | char * | key
| ) |  |

Gets the localised value for a specified key in MBDotDesktop instance.

Parameters

  dd | MBDotDesktop instance
  key | requested key.

Returns
  values, NULL on fail

char* mb_dotdesktop_get_exec | ( | MBDotDesktop * | dd | ) |

Get the Exec key from a MBDotDesktop instance, with the %-escapes expanded.

Unlike mb_dotdesktop_get(), this string needs to be free()d.

Parameters

  dd | MBDotDesktop instance

Returns
  file name, NULL on fail

char* mb_dotdesktop_get_filename | ( | MBDotDesktop * | dd | ) |

Gets the filename from MBDotDesktop instance.

Parameters

  dd | MBDotDesktop instance

Returns
  filename of MBDotDesktop, NULL on fail

MBDotDesktop* mb_dotdesktop_new_from_file | ( | const char * | filename | ) |

Parses a .desktop file and creates a localised MBDotDesktop instance.

Parameters

  filename | full path to .desktop file

Returns
  MBDotDesktop instance, NULL on fail